package cn.roadflow.common;

import cn.roadflow.controller.BasePage;
import cn.roadflow.model.workflowRun.WorkFlowEventParamModel;
import cn.roadflow.service.Organize;
import cn.roadflow.service.WorkFlowTask;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * 通配符类
 */
public class Wildcard {
    /**
     * 系统包含的通配符
     */
    private static List<String> wildcards = null;

    public static List<String> getWildcards() {
        if (null == wildcards) {
            wildcards = new ArrayList<>();
            wildcards.add("{<userId>}");
            wildcards.add("{<userName>}");
            wildcards.add("{<userDeptId>}");
            wildcards.add("{<userDeptName>}");
            wildcards.add("{<userStationId>}");
            wildcards.add("{<userStationName>}");
            wildcards.add("{<userRoleId>}");
            wildcards.add("{<userRoleName>}");
            wildcards.add("{<userDeptLeaderId>}");
            wildcards.add("{<userDeptLeaderName>}");
            wildcards.add("{<userCharegLeaderId>}");
            wildcards.add("{<userCharegLeaderName>}");
            wildcards.add("{<userUnitId>}");
            wildcards.add("{<userUnitName>}");
            wildcards.add("{<initiatorId>}");
            wildcards.add("{<initiatorName>}");
            wildcards.add("{<initiatorDeptId>}");
            wildcards.add("{<initiatorDeptName>}");
            wildcards.add("{<initiatorStationId>}");
            wildcards.add("{<initiatorStationName>}");
            wildcards.add("{<initiatorRoleId>}");
            wildcards.add("{<initiatorRoleName>}");
            wildcards.add("{<initiatorUnitId>}");
            wildcards.add("{<initiatorUnitName>}");
            wildcards.add("{<initiatorLeaderId>}");
            wildcards.add("{<initiatorLeaderName>}");
            wildcards.add("{<initiatorCharegId>}");
            wildcards.add("{<initiatorCharegName>}");
            wildcards.add("{<shortDate>}");
            wildcards.add("{<longDate>}");
            wildcards.add("{<shortDateTime>}");
            wildcards.add("{<longDateTime>}");
            wildcards.add("{<shortDateTimeSecond>}");
            wildcards.add("{<longDateTimeSecond>}");
            wildcards.add("{<flowId>}");
            wildcards.add("{<flowName>}");
            wildcards.add("{<flowStepId>}");
            wildcards.add("{<flowStepName>}");
            wildcards.add("{<flowTaskId>}");
            wildcards.add("{<flowInstanceId>}");
            wildcards.add("{<flowGroupId>}");
            wildcards.add("{<UUID>}");
            wildcards.add("{<emptyUUID>}");

            wildcards.add("{getParameter<");
            wildcards.add("{Map<");
            wildcards.add("{Date<");
            wildcards.add("{Method<");
        }
        return wildcards;
    }

    /**
     * 得到通配符的值
     * @param wildcard 通配符
     * @param object   对象中包含通配符的KEY如Map
     * @return
     */
    public static String getWildcardValue(String wildcard, String userId, Object object) {
        if (StringExt.isBlank(userId)) {
            userId = new BasePage().getCurrentUserId();
        }
        Organize organize = new Organize();
        switch (wildcard) {
            case "{<userId>}"://当前用户ID
                return new BasePage().getCurrentUserId();
            case "{<userName>}"://当前用户姓名
                return new BasePage().getCurrentUserName();
            case "{<userDeptId>}"://当前用户部门ID
                return organize.getUserDeptId(userId);
            case "{<userDeptName>}"://当前用户部门名称
                return organize.getUserDeptName(userId);
            case "{<userStationId>}"://当前用户岗位ID
                return organize.getUserStationId(userId);
            case "{<userStationName>}"://当前用户岗位名称
                return organize.getUserStationName(userId);
            case "{<userRoleId>}"://当前用户角色组ID
                return organize.getUserWorkGroupIds(userId);
            case "{<userRoleName>}"://当前用户角色组名称
                return organize.getUserWorkGroupNames(userId);
            case "{<userDeptLeaderId>}"://当前用户部门领导ID
                return organize.getUserDeptLeaderIds(userId);
            case "{<userDeptLeaderName>}"://当前用户部门领导姓名
                return organize.getUserDeptLeaderNames(userId);
            case "{<userCharegLeaderId>}"://当前用户分管领导ID
                return organize.getUserCharegLeaderIds(userId);
            case "{<userCharegLeaderName>}"://当前用户分管领导姓名
                return organize.getUserCharegLeaderNames(userId);
            case "{<userUnitId>}"://当前用户单位ID
                return organize.getUserUnitId(userId);
            case "{<userUnitName>}"://当前用户单位名称
                return organize.getUserUnitName(userId);
            case "{<initiatorId>}"://发起者ID
                String firstId = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return StringExt.isBlank(firstId) ? userId : firstId;
            case "{<initiatorName>}"://发起者姓名
                String firstId1 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserName(StringExt.isBlank(firstId1) ? userId : firstId1);
            case "{<initiatorDeptId>}"://发起者部门ID
                String firstId2 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserDeptId(StringExt.isBlank(firstId2) ? userId : firstId2);
            case "{<initiatorDeptName>}"://发起者部门名称
                String firstId3 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserDeptName(StringExt.isBlank(firstId3) ? userId : firstId3);
            case "{<initiatorStationId>}"://发起者岗位ID
                String firstId4 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserStationId(StringExt.isBlank(firstId4) ? userId : firstId4);
            case "{<initiatorStationName>}"://发起者岗位名称
                String firstId5 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserStationName(StringExt.isBlank(firstId5) ? userId : firstId5);
            case "{<initiatorRoleId>}"://发起者角色组ID
                String firstId6 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserWorkGroupIds(StringExt.isBlank(firstId6) ? userId : firstId6);
            case "{<initiatorRoleName>}"://发起者角色组名称
                String firstId7 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserWorkGroupNames(StringExt.isBlank(firstId7) ? userId : firstId7);
            case "{<initiatorUnitId>}"://发起者单位ID
                String firstId8 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserUnitId(StringExt.isBlank(firstId8) ? userId : firstId8);
            case "{<initiatorUnitName>}"://发起者单位名称
                String firstId9 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserUnitName(StringExt.isBlank(firstId9) ? userId : firstId9);
            case "{<initiatorLeaderId>}"://发起者部门领导ID
                String firstId10 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserDeptLeaderIds(StringExt.isBlank(firstId10) ? userId : firstId10);
            case "{<initiatorLeaderName>}"://发起者部门领导姓名
                String firstId11 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserDeptLeaderNames(StringExt.isBlank(firstId11) ? userId : firstId11);
            case "{<initiatorCharegId>}"://发起者分管领导ID
                String firstId12 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserCharegLeaderIds(StringExt.isBlank(firstId12) ? userId : firstId12);
            case "{<initiatorCharegName>}"://发起者分管领导姓名
                String firstId13 = new WorkFlowTask().getFirstSnderId(Tools.getParameter(null, "groupid"));
                return organize.getUserCharegLeaderNames(StringExt.isBlank(firstId13) ? userId : firstId13);
            case "{<shortDate>}"://短日期格式(yyyy-MM-dd)
                return DateExt.formatShortDate(DateExt.getDate());
            case "{<longDate>}"://长日期格式(yyyy年MM月dd日)
                return DateExt.formatLongDate(DateExt.getDate());
            case "{<shortDateTime>}"://短日期时间(yyyy-MM-dd HH:mm)
                return DateExt.formatShortDateTime(DateExt.getDate());
            case "{<longDateTime>}"://长日期格式(yyyy年MM月dd日 HH时mm分)
                return DateExt.formatLongDateTime(DateExt.getDate());
            case "{<shortDateTimeSecond>}"://短日期时间(yyyy-MM-dd HH:mm:ss)
                return DateExt.formatShortDateTimeSecond(DateExt.getDate());
            case "{<longDateTimeSecond>}"://长日期格式(yyyy年MM月dd日 HH时mm分ss秒)
                return DateExt.formatLongDateTimeSecond(DateExt.getDate());
            case "{<UUID>}"://随机生成UUID
                return UUIDExt.getUUID();
            case "{<emptyUUID>}"://空UUID
                return UUIDExt.getEmptyUUID();
        }
        return "";
    }

    /**
     * 过滤通配符
     * @param string
     * @return
     */
    public static String filterWildcard(String string) {
        return filterWildcard(string, "", null);
    }

    /**
     * 过滤通配符
     * @param string
     * @param userId
     * @param object
     * @return
     */
    public static String filterWildcard(String string, String userId, Object object) {
        if (StringExt.isBlank(string)) {
            return "";
        }
        for (String wildcard : getWildcards()) {
            while (StringExt.contains(string, wildcard)) {
                String value = null;
                String wildcard1 = null;
                if ("{getParameter<".equals(wildcard)) {
                    String key = StringExt.substring(string, string.indexOf("{getParameter<") + 14);
                    String key1 = StringExt.substring(key, 0, key.indexOf(">}"));
                    if (StringExt.isNotBlank(key1)) {
                        wildcard1 = wildcard + key1 + ">}";
                        value = Tools.getParameter(null, key1);
                    }
                } else if ("{Map<".equals(wildcard) && null != object) {
                    String key = StringExt.substring(string, string.indexOf("{Map<") + 5);
                    String key1 = StringExt.substring(key, 0, key.indexOf(">}"));
                    if (StringExt.isNotBlank(key1)) {
                        wildcard1 = wildcard + key1 + ">}";
                        try {
                            Map<String, Object> map = (Map<String, Object>) object;
                            Object object1 = map.containsKey(key1) ? map.get(key1) : null;
                            value = StringExt.valueOf(object1);
                        } catch (Exception e) {
                            value = "";
                        }
                    }
                } else if ("{Method<".equals(wildcard)) { //执行一个方法替换通配符 object为方法参数
                    String key = StringExt.substring(string, string.indexOf("{Method<") + 8);
                    String key1 = StringExt.substring(key, 0, key.indexOf(">}"));
                    if (StringExt.isNotBlank(key1)) {
                        wildcard1 = wildcard + key1 + ">}";
                        Object o = Tools.executeMethod(key1, object);
                        value = null == o ? "" : String.valueOf(o);
                    }
                } else if ("{Date<".equals(wildcard)) { //取当前日期替换指定格式
                    String key = StringExt.substring(string, string.indexOf("{Date<") + 6);
                    String key1 = StringExt.substring(key, 0, key.indexOf(">}"));
                    if (StringExt.isNotBlank(key1)) {
                        wildcard1 = wildcard + key1 + ">}";
                        try {
                            value = DateExt.format(DateExt.getDate(), key1);
                        } catch (Exception e){
                            value = "";
                        }
                    }
                } else {
                    wildcard1 = wildcard;
                    value = getWildcardValue(wildcard, userId, object);
                }
                string = StringExt.replace(string, wildcard1, value);
            }
        }
        return string;
    }

}
